import socket
import random
import sys
import threading
import time
from threading import Thread
import ecc
import cryptor

HOST = ''
PORT = 5000

#curves for ECDH, format [a, b, p] -> y**2 = x**3 + a*x + b mod p; [x, y] are a point on the EC
curves = [
            [[23749, 409741011, 426546346592070269], [729,28539]],
            [[9326, 1376127157, 354990952970600489], [4093588398, 494204038]],
            [[30800, 1187016249, 546422503250358263], [1146878855, 243009781]],
            [[16057, 421810025, 322083043555692967], [2478569373, 360426459]],
            [[32593, 1864507527, 560147175803221327], [2309607047, 53492280]]
         ]


#global inits
curveIndex = 0                        #Mit jeder Verbindung inkrementiert mod 5, als Index in die EC Tabelle
#!!!zum generieren des pcap connNumber auf 1 setzen und in der ersten Verbindung capturen
connNumber = 2                        #Nummer der Verbindung, wird an den Client gesendet (benoetigt um aus einem d die vorherigen zu berechnen)
globalLock = threading.Lock()        #Lock um den PRNG, curveIndex und connNumber threadsafe zu machen
random.seed("F1ut5chF1ng3r5")        #konstanter Seed damit bei einem Neustart des Scripts die gleichen private Keys (d) generiert werden
d = random.randint(1, 2**56)

#print d

def readline(s):
    buffer = ""
    while 1:
        data = s.recv(1)
        if not data:
            raise Exception
        elif data == '\n':
            break
        buffer += data
    return buffer
def sendline(s, buf):
    buf += "\n"
    s.send(buf)
def readpoint(s):
    buffer = readline(s)
    buffer = buffer.split(",")
    if len(buffer) != 2:
        raise Exception
    x = buffer[0]
    y = buffer[1]
    return int(x), int(y)
def sendpoint(s, x, y):
    sendline(s, "%s,%s" %(x, y))
def readcurve(s):
    buffer = readline(s)
    buffer = buffer.split(",")
    if len(buffer) != 3:
        raise Exception
    a = buffer[0]
    b = buffer[1]
    p = buffer[2]
    return int(a), int(b), int(p)
def sendcurve(s, a, b, p):
    sendline(s, ("%s,%s,%s" % (a, b, p)))
    
    
class connection(Thread):
    def __init__(self, comm, addr):
        Thread.__init__(self)
        self.comm = comm
        self.addr = addr
        self.status = -1
    def run(self):
        print "Incoming connection from %s:%s" % (addr[0], addr[1])
        with globalLock:
            #begin critical section
            global curveIndex, connNumber
            localCurveIndex = curveIndex
            curveIndex = (curveIndex + 1) % 5
            localConnNumber = connNumber
            connNumber += 1
            privKey = d + localConnNumber
            #end critical section
            
        a = curves[curveIndex][0][0]
        b = curves[curveIndex][0][1]
        p = curves[curveIndex][0][2]
        prim_x = curves[curveIndex][1][0]
        prim_y = curves[curveIndex][1][1]
        
        try:
            sendline(comm, "Establishing secure connection via ECDH...")
            sendcurve(comm, a, b, p)
            sendpoint(comm, prim_x, prim_y)
            sendline(comm, "Accept? y/n")
            data = readline(comm)
            if data == "n":
                sendline(comm, "Waiting for point")
                prim_x, prim_y = readpoint(comm)
            elif data == "y":
                pass
            else:
                sendline(comm, "Illegal response, aborting")
                raise Exception
                
            if ecc.isPointOnCurve(prim_x, prim_y, a, b, p) == 0:
                sendline(comm, "Illegal point, aborting")
                raise Exception
            
            server_x, server_y = ecc.pointMultiplication(prim_x, prim_y, privKey, a, p)
            sendpoint(comm, server_x, server_y)
            
            client_x, client_y = readpoint(comm)
            if ecc.isPointOnCurve(client_x, client_y, a, b, p) == 0:
                sendline(comm, "Illegal point, aborting")
                raise Exception
            priv_x, priv_y = ecc.pointMultiplication(client_x, client_y, privKey, a, p)

            print "G", prim_x, prim_y
            print "SERVER", server_x, server_y
            print "CLIENT", client_x, client_y
            print "COMMON", priv_x, priv_y
            print "d=", privKey
            print
            c = cryptor.cryptor(priv_x, priv_y, "server")
            
            sendline(comm, c.encrypt("Successfully established the %s. secure connection for today" %localConnNumber))
            sendline(comm, c.encrypt("Waiting for operator to jump in"))
            #zum generieren des pcap
            #while True:
            #    msg = raw_input("Message: ")
            #    sendline(comm, c.encrypt(msg)) 
            #    print c.decrypt(readline(comm))
                        
            time.sleep(10)
            sendline(comm, c.encrypt("There is currently no operator available, please try again later"))
            sendline(comm, c.encrypt("Closing connection"))
        except:
            pass
        finally:
            comm.close()
            

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM) 
s.bind((HOST, PORT)) 
s.listen(5)

try: 
    while True: 
        comm, addr = s.accept()
        current = connection(comm, addr)
        current.start()
        
finally: 
    s.close()
    print "\n\n\n!!!Script stopped, this should not happen!!!\n\n\n"
